MCU_init_reset:                        ; Reset vector code

        ; MMCCTL1: TGMRAMON=0,EEEIFRON=0,PGMIFRON=0,RAMHM=0,EROMON=0,ROMHM=0,ROMON=1 
        MOVB    #1,MMCCTL1                                        
        ; DIRECT: DP15=0,DP14=0,DP13=0,DP12=0,DP11=0,DP10=0,DP9=0,DP8=0 
        CLR     DIRECT                                               
        ; IVBR: IVB_ADDR=255 
        MOVB    #255,IVBR                                        
        ; ECLKCTL: NECLK=1,NCLKX2=1,DIV16=0,EDIV4=0,EDIV3=0,EDIV2=0,EDIV1=0,EDIV0=0 
        MOVB    #192,ECLKCTL                                        
        ; Jump to the default entry point
        jmp _Startup



;** ===================================================================
;**     Method      :  MCU_init (bean MC9S12XEP100_112)
;**
;**     Description :
;**         Device initialization code for selected peripherals.
;** ===================================================================
MCU_init:

  ; ### MC9S12XEP100_112 "Cpu" init code ... 
  ;  System clock initialization 
        ; CLKSEL: PLLSEL=0,PSTP=0,XCLKS=0,PLLWAI=0,RTIWAI=0,COPWAI=0 
        CLR     CLKSEL                 ; Select clock source from XTAL and set bits in CLKSEL reg. 
        ; PLLCTL: CME=1,PLLON=0,FM1=0,FM0=0,FSTWKP=0,PRE=0,PCE=0,SCME=1 
        MOVB    #129,PLLCTL            ; Disable the PLL 
        ; VREGHTCL: VSEL=0,VAE=1,HTEN=0,HTDS=0,HTIE=0,HTIF=0 
        MOVB    #16,VREGHTCL                                        
  ; Initialization of Memory Protection unit 
        ; MPUSEL: SVSEN=0,SEL=1 
        MOVB    #1,MPUSEL              ; Select Descriptor num. 1 
        ; MPUDESC2: LOW_ADDR10=0,LOW_ADDR9=0,LOW_ADDR8=0,LOW_ADDR7=0,LOW_ADDR6=0,LOW_ADDR5=0,LOW_ADDR4=0,LOW_ADDR3=0 
        CLR     MPUDESC2                                               
        ; MPUDESC1: LOW_ADDR18=0,LOW_ADDR17=0,LOW_ADDR16=0,LOW_ADDR15=0,LOW_ADDR14=0,LOW_ADDR13=0,LOW_ADDR12=0,LOW_ADDR11=0 
        CLR     MPUDESC1                                               
        ; MPUDESC0: MSTR0=0,MSTR1=0,MSTR2=0,MSTR3=0,LOW_ADDR22=0,LOW_ADDR21=0,LOW_ADDR20=0,LOW_ADDR19=0 
        CLR     MPUDESC0                                               
        ; MPUDESC5: HIGH_ADDR10=1,HIGH_ADDR9=1,HIGH_ADDR8=1,HIGH_ADDR7=1,HIGH_ADDR6=1,HIGH_ADDR5=1,HIGH_ADDR4=1,HIGH_ADDR3=1 
        MOVB    #255,MPUDESC5                                        
        ; MPUDESC4: HIGH_ADDR18=1,HIGH_ADDR17=1,HIGH_ADDR16=1,HIGH_ADDR15=1,HIGH_ADDR14=1,HIGH_ADDR13=1,HIGH_ADDR12=1,HIGH_ADDR11=1 
        MOVB    #255,MPUDESC4                                        
        ; MPUDESC3: WP=0,NEX=0,HIGH_ADDR22=1,HIGH_ADDR21=1,HIGH_ADDR20=1,HIGH_ADDR19=1 
        MOVB    #15,MPUDESC3                                        
        ; MPUSEL: SVSEN=0,SEL=2 
        MOVB    #2,MPUSEL              ; Select Descriptor num. 2 
        ; MPUDESC2: LOW_ADDR10=0,LOW_ADDR9=0,LOW_ADDR8=0,LOW_ADDR7=0,LOW_ADDR6=0,LOW_ADDR5=0,LOW_ADDR4=0,LOW_ADDR3=0 
        CLR     MPUDESC2                                               
        ; MPUDESC1: LOW_ADDR18=0,LOW_ADDR17=0,LOW_ADDR16=0,LOW_ADDR15=0,LOW_ADDR14=0,LOW_ADDR13=0,LOW_ADDR12=0,LOW_ADDR11=0 
        CLR     MPUDESC1                                               
        ; MPUDESC0: MSTR0=0,MSTR1=0,MSTR2=0,MSTR3=0,LOW_ADDR22=0,LOW_ADDR21=0,LOW_ADDR20=0,LOW_ADDR19=0 
        CLR     MPUDESC0                                               
        ; MPUDESC5: HIGH_ADDR10=1,HIGH_ADDR9=1,HIGH_ADDR8=1,HIGH_ADDR7=1,HIGH_ADDR6=1,HIGH_ADDR5=1,HIGH_ADDR4=1,HIGH_ADDR3=1 
        MOVB    #255,MPUDESC5                                        
        ; MPUDESC4: HIGH_ADDR18=1,HIGH_ADDR17=1,HIGH_ADDR16=1,HIGH_ADDR15=1,HIGH_ADDR14=1,HIGH_ADDR13=1,HIGH_ADDR12=1,HIGH_ADDR11=1 
        MOVB    #255,MPUDESC4                                        
        ; MPUDESC3: WP=0,NEX=0,HIGH_ADDR22=1,HIGH_ADDR21=1,HIGH_ADDR20=1,HIGH_ADDR19=1 
        MOVB    #15,MPUDESC3                                        
        ; MPUSEL: SVSEN=0,SEL=3 
        MOVB    #3,MPUSEL              ; Select Descriptor num. 3 
        ; MPUDESC2: LOW_ADDR10=0,LOW_ADDR9=0,LOW_ADDR8=0,LOW_ADDR7=0,LOW_ADDR6=0,LOW_ADDR5=0,LOW_ADDR4=0,LOW_ADDR3=0 
        CLR     MPUDESC2                                               
        ; MPUDESC1: LOW_ADDR18=0,LOW_ADDR17=0,LOW_ADDR16=0,LOW_ADDR15=0,LOW_ADDR14=0,LOW_ADDR13=0,LOW_ADDR12=0,LOW_ADDR11=0 
        CLR     MPUDESC1                                               
        ; MPUDESC0: MSTR0=0,MSTR1=0,MSTR2=0,MSTR3=0,LOW_ADDR22=0,LOW_ADDR21=0,LOW_ADDR20=0,LOW_ADDR19=0 
        CLR     MPUDESC0                                               
        ; MPUDESC5: HIGH_ADDR10=1,HIGH_ADDR9=1,HIGH_ADDR8=1,HIGH_ADDR7=1,HIGH_ADDR6=1,HIGH_ADDR5=1,HIGH_ADDR4=1,HIGH_ADDR3=1 
        MOVB    #255,MPUDESC5                                        
        ; MPUDESC4: HIGH_ADDR18=1,HIGH_ADDR17=1,HIGH_ADDR16=1,HIGH_ADDR15=1,HIGH_ADDR14=1,HIGH_ADDR13=1,HIGH_ADDR12=1,HIGH_ADDR11=1 
        MOVB    #255,MPUDESC4                                        
        ; MPUDESC3: WP=0,NEX=0,HIGH_ADDR22=1,HIGH_ADDR21=1,HIGH_ADDR20=1,HIGH_ADDR19=1 
        MOVB    #15,MPUDESC3                                        
        ; MPUSEL: SVSEN=0,SEL=4 
        MOVB    #4,MPUSEL              ; Select Descriptor num. 4 
        ; MPUDESC2: LOW_ADDR10=0,LOW_ADDR9=0,LOW_ADDR8=0,LOW_ADDR7=0,LOW_ADDR6=0,LOW_ADDR5=0,LOW_ADDR4=0,LOW_ADDR3=0 
        CLR     MPUDESC2                                               
        ; MPUDESC1: LOW_ADDR18=0,LOW_ADDR17=0,LOW_ADDR16=0,LOW_ADDR15=0,LOW_ADDR14=0,LOW_ADDR13=0,LOW_ADDR12=0,LOW_ADDR11=0 
        CLR     MPUDESC1                                               
        ; MPUDESC0: MSTR0=0,MSTR1=0,MSTR2=0,MSTR3=0,LOW_ADDR22=0,LOW_ADDR21=0,LOW_ADDR20=0,LOW_ADDR19=0 
        CLR     MPUDESC0                                               
        ; MPUDESC5: HIGH_ADDR10=1,HIGH_ADDR9=1,HIGH_ADDR8=1,HIGH_ADDR7=1,HIGH_ADDR6=1,HIGH_ADDR5=1,HIGH_ADDR4=1,HIGH_ADDR3=1 
        MOVB    #255,MPUDESC5                                        
        ; MPUDESC4: HIGH_ADDR18=1,HIGH_ADDR17=1,HIGH_ADDR16=1,HIGH_ADDR15=1,HIGH_ADDR14=1,HIGH_ADDR13=1,HIGH_ADDR12=1,HIGH_ADDR11=1 
        MOVB    #255,MPUDESC4                                        
        ; MPUDESC3: WP=0,NEX=0,HIGH_ADDR22=1,HIGH_ADDR21=1,HIGH_ADDR20=1,HIGH_ADDR19=1 
        MOVB    #15,MPUDESC3                                        
        ; MPUSEL: SVSEN=0,SEL=5 
        MOVB    #5,MPUSEL              ; Select Descriptor num. 5 
        ; MPUDESC2: LOW_ADDR10=0,LOW_ADDR9=0,LOW_ADDR8=0,LOW_ADDR7=0,LOW_ADDR6=0,LOW_ADDR5=0,LOW_ADDR4=0,LOW_ADDR3=0 
        CLR     MPUDESC2                                               
        ; MPUDESC1: LOW_ADDR18=0,LOW_ADDR17=0,LOW_ADDR16=0,LOW_ADDR15=0,LOW_ADDR14=0,LOW_ADDR13=0,LOW_ADDR12=0,LOW_ADDR11=0 
        CLR     MPUDESC1                                               
        ; MPUDESC0: MSTR0=0,MSTR1=0,MSTR2=0,MSTR3=0,LOW_ADDR22=0,LOW_ADDR21=0,LOW_ADDR20=0,LOW_ADDR19=0 
        CLR     MPUDESC0                                               
        ; MPUDESC5: HIGH_ADDR10=1,HIGH_ADDR9=1,HIGH_ADDR8=1,HIGH_ADDR7=1,HIGH_ADDR6=1,HIGH_ADDR5=1,HIGH_ADDR4=1,HIGH_ADDR3=1 
        MOVB    #255,MPUDESC5                                        
        ; MPUDESC4: HIGH_ADDR18=1,HIGH_ADDR17=1,HIGH_ADDR16=1,HIGH_ADDR15=1,HIGH_ADDR14=1,HIGH_ADDR13=1,HIGH_ADDR12=1,HIGH_ADDR11=1 
        MOVB    #255,MPUDESC4                                        
        ; MPUDESC3: WP=0,NEX=0,HIGH_ADDR22=1,HIGH_ADDR21=1,HIGH_ADDR20=1,HIGH_ADDR19=1 
        MOVB    #15,MPUDESC3                                        
        ; MPUSEL: SVSEN=0,SEL=6 
        MOVB    #6,MPUSEL              ; Select Descriptor num. 6 
        ; MPUDESC2: LOW_ADDR10=0,LOW_ADDR9=0,LOW_ADDR8=0,LOW_ADDR7=0,LOW_ADDR6=0,LOW_ADDR5=0,LOW_ADDR4=0,LOW_ADDR3=0 
        CLR     MPUDESC2                                               
        ; MPUDESC1: LOW_ADDR18=0,LOW_ADDR17=0,LOW_ADDR16=0,LOW_ADDR15=0,LOW_ADDR14=0,LOW_ADDR13=0,LOW_ADDR12=0,LOW_ADDR11=0 
        CLR     MPUDESC1                                               
        ; MPUDESC0: MSTR0=0,MSTR1=0,MSTR2=0,MSTR3=0,LOW_ADDR22=0,LOW_ADDR21=0,LOW_ADDR20=0,LOW_ADDR19=0 
        CLR     MPUDESC0                                               
        ; MPUDESC5: HIGH_ADDR10=1,HIGH_ADDR9=1,HIGH_ADDR8=1,HIGH_ADDR7=1,HIGH_ADDR6=1,HIGH_ADDR5=1,HIGH_ADDR4=1,HIGH_ADDR3=1 
        MOVB    #255,MPUDESC5                                        
        ; MPUDESC4: HIGH_ADDR18=1,HIGH_ADDR17=1,HIGH_ADDR16=1,HIGH_ADDR15=1,HIGH_ADDR14=1,HIGH_ADDR13=1,HIGH_ADDR12=1,HIGH_ADDR11=1 
        MOVB    #255,MPUDESC4                                        
        ; MPUDESC3: WP=0,NEX=0,HIGH_ADDR22=1,HIGH_ADDR21=1,HIGH_ADDR20=1,HIGH_ADDR19=1 
        MOVB    #15,MPUDESC3                                        
        ; MPUSEL: SVSEN=0,SEL=7 
        MOVB    #7,MPUSEL              ; Select Descriptor num. 7 
        ; MPUDESC2: LOW_ADDR10=0,LOW_ADDR9=0,LOW_ADDR8=0,LOW_ADDR7=0,LOW_ADDR6=0,LOW_ADDR5=0,LOW_ADDR4=0,LOW_ADDR3=0 
        CLR     MPUDESC2                                               
        ; MPUDESC1: LOW_ADDR18=0,LOW_ADDR17=0,LOW_ADDR16=0,LOW_ADDR15=0,LOW_ADDR14=0,LOW_ADDR13=0,LOW_ADDR12=0,LOW_ADDR11=0 
        CLR     MPUDESC1                                               
        ; MPUDESC0: MSTR0=0,MSTR1=0,MSTR2=0,MSTR3=0,LOW_ADDR22=0,LOW_ADDR21=0,LOW_ADDR20=0,LOW_ADDR19=0 
        CLR     MPUDESC0                                               
        ; MPUDESC5: HIGH_ADDR10=1,HIGH_ADDR9=1,HIGH_ADDR8=1,HIGH_ADDR7=1,HIGH_ADDR6=1,HIGH_ADDR5=1,HIGH_ADDR4=1,HIGH_ADDR3=1 
        MOVB    #255,MPUDESC5                                        
        ; MPUDESC4: HIGH_ADDR18=1,HIGH_ADDR17=1,HIGH_ADDR16=1,HIGH_ADDR15=1,HIGH_ADDR14=1,HIGH_ADDR13=1,HIGH_ADDR12=1,HIGH_ADDR11=1 
        MOVB    #255,MPUDESC4                                        
        ; MPUDESC3: WP=0,NEX=0,HIGH_ADDR22=1,HIGH_ADDR21=1,HIGH_ADDR20=1,HIGH_ADDR19=1 
        MOVB    #15,MPUDESC3                                        
        ; MPUSEL: SVSEN=0,SEL=0 
        CLR     MPUSEL                 ; Select Descriptor num. 0 
        ; MPUDESC2: LOW_ADDR10=0,LOW_ADDR9=0,LOW_ADDR8=0,LOW_ADDR7=0,LOW_ADDR6=0,LOW_ADDR5=0,LOW_ADDR4=0,LOW_ADDR3=0 
        CLR     MPUDESC2                                               
        ; MPUDESC1: LOW_ADDR18=0,LOW_ADDR17=0,LOW_ADDR16=0,LOW_ADDR15=0,LOW_ADDR14=0,LOW_ADDR13=0,LOW_ADDR12=0,LOW_ADDR11=0 
        CLR     MPUDESC1                                               
        ; MPUDESC0: MSTR0=1,MSTR1=1,MSTR2=1,MSTR3=0,LOW_ADDR22=0,LOW_ADDR21=0,LOW_ADDR20=0,LOW_ADDR19=0 
        MOVB    #224,MPUDESC0                                        
        ; MPUDESC5: HIGH_ADDR10=1,HIGH_ADDR9=1,HIGH_ADDR8=1,HIGH_ADDR7=1,HIGH_ADDR6=1,HIGH_ADDR5=1,HIGH_ADDR4=1,HIGH_ADDR3=1 
        MOVB    #255,MPUDESC5                                        
        ; MPUDESC4: HIGH_ADDR18=1,HIGH_ADDR17=1,HIGH_ADDR16=1,HIGH_ADDR15=1,HIGH_ADDR14=1,HIGH_ADDR13=1,HIGH_ADDR12=1,HIGH_ADDR11=1 
        MOVB    #255,MPUDESC4                                        
        ; MPUDESC3: WP=0,NEX=0,HIGH_ADDR22=1,HIGH_ADDR21=1,HIGH_ADDR20=1,HIGH_ADDR19=1 
        MOVB    #15,MPUDESC3                                        
  ; Int. priority initialization 
  ;                                         No. Address Pri XGATE Name            Description 
        MOVB    #16,INT_CFADDR                                        
        MOVB    #1,INT_CFDATA4         ;  0x0C  0xFF18   1   no   ivVReserved115  unused by PE 
        MOVB    #1,INT_CFDATA5         ;  0x0D  0xFF1A   1   no   ivVReserved114  unused by PE 
        MOVB    #1,INT_CFDATA6         ;  0x0E  0xFF1C   1   no   ivVReserved113  unused by PE 
        MOVB    #1,INT_CFDATA7         ;  0x0F  0xFF1E   1   no   ivVReserved112  unused by PE 
        MOVB    #32,INT_CFADDR                                        
        MOVB    #1,INT_CFDATA0         ;  0x10  0xFF20   1   no   ivVReserved111  unused by PE 
        MOVB    #1,INT_CFDATA1         ;  0x11  0xFF22   1   no   ivVReserved110  unused by PE 
        MOVB    #1,INT_CFDATA2         ;  0x12  0xFF24   1   no   ivVReserved109  unused by PE 
        MOVB    #1,INT_CFDATA3         ;  0x13  0xFF26   1   no   ivVReserved108  unused by PE 
        MOVB    #1,INT_CFDATA4         ;  0x14  0xFF28   1   no   ivVReserved107  unused by PE 
        MOVB    #1,INT_CFDATA5         ;  0x15  0xFF2A   1   no   ivVReserved106  unused by PE 
        MOVB    #1,INT_CFDATA6         ;  0x16  0xFF2C   1   no   ivVReserved105  unused by PE 
        MOVB    #1,INT_CFDATA7         ;  0x17  0xFF2E   1   no   ivVReserved104  unused by PE 
        MOVB    #48,INT_CFADDR                                        
        MOVB    #1,INT_CFDATA0         ;  0x18  0xFF30   1   no   ivVReserved103  unused by PE 
        MOVB    #1,INT_CFDATA1         ;  0x19  0xFF32   1   no   ivVReserved102  unused by PE 
        MOVB    #1,INT_CFDATA2         ;  0x1A  0xFF34   1   no   ivVReserved101  unused by PE 
        MOVB    #1,INT_CFDATA3         ;  0x1B  0xFF36   1   no   ivVReserved100  unused by PE 
        MOVB    #1,INT_CFDATA4         ;  0x1C  0xFF38   1   no   ivVReserved99   unused by PE 
        MOVB    #1,INT_CFDATA5         ;  0x1D  0xFF3A   1   no   ivVReserved98   unused by PE 
        MOVB    #1,INT_CFDATA6         ;  0x1E  0xFF3C   1   no   ivVatd1compare  unused by PE 
        MOVB    #1,INT_CFDATA7         ;  0x1F  0xFF3E   1   no   ivVatd0compare  unused by PE 
        MOVB    #64,INT_CFADDR                                        
        MOVB    #1,INT_CFDATA0         ;  0x20  0xFF40   1   no   ivVtimpaie      used by PE 
        MOVB    #1,INT_CFDATA1         ;  0x21  0xFF42   1   no   ivVtimpaaovf    used by PE 
        MOVB    #1,INT_CFDATA2         ;  0x22  0xFF44   1   no   ivVtimovf       used by PE 
        MOVB    #1,INT_CFDATA3         ;  0x23  0xFF46   1   no   ivVtimch7       unused by PE 
        MOVB    #1,INT_CFDATA4         ;  0x24  0xFF48   1   no   ivVtimch6       unused by PE 
        MOVB    #1,INT_CFDATA5         ;  0x25  0xFF4A   1   no   ivVtimch5       unused by PE 
        MOVB    #1,INT_CFDATA6         ;  0x26  0xFF4C   1   no   ivVtimch4       unused by PE 
        MOVB    #1,INT_CFDATA7         ;  0x27  0xFF4E   1   no   ivVtimch3       used by PE 
        MOVB    #80,INT_CFADDR                                        
        MOVB    #1,INT_CFDATA0         ;  0x28  0xFF50   2   no   ivVtimch2       used by PE 
        MOVB    #1,INT_CFDATA1         ;  0x29  0xFF52   1   no   ivVtimch1       unused by PE 
        MOVB    #1,INT_CFDATA2         ;  0x2A  0xFF54   2   no   ivVtimch0       used by PE 
        MOVB    #1,INT_CFDATA3         ;  0x2B  0xFF56   1   no   ivVsci7         unused by PE 
        MOVB    #1,INT_CFDATA4         ;  0x2C  0xFF58   1   no   ivVpit7         unused by PE 
        MOVB    #1,INT_CFDATA5         ;  0x2D  0xFF5A   1   no   ivVpit6         unused by PE 
        MOVB    #1,INT_CFDATA6         ;  0x2E  0xFF5C   1   no   ivVpit5         unused by PE 
        MOVB    #1,INT_CFDATA7         ;  0x2F  0xFF5E   1   no   ivVpit4         unused by PE 
        MOVB    #96,INT_CFADDR                                        
        MOVB    #1,INT_CFDATA0         ;  0x30  0xFF60   1   no   ivVReserved79   unused by PE 
        MOVB    #1,INT_CFDATA1         ;  0x31  0xFF62   1   no   ivVReserved78   unused by PE 
        MOVB    #1,INT_CFDATA2         ;  0x32  0xFF64   1   no   ivVxst7         unused by PE 
        MOVB    #1,INT_CFDATA3         ;  0x33  0xFF66   1   no   ivVxst6         unused by PE 
        MOVB    #1,INT_CFDATA4         ;  0x34  0xFF68   1   no   ivVxst5         unused by PE 
        MOVB    #1,INT_CFDATA5         ;  0x35  0xFF6A   1   no   ivVxst4         unused by PE 
        MOVB    #1,INT_CFDATA6         ;  0x36  0xFF6C   1   no   ivVxst3         unused by PE 
        MOVB    #1,INT_CFDATA7         ;  0x37  0xFF6E   1   no   ivVxst2         unused by PE 
        MOVB    #112,INT_CFADDR                                        
        MOVB    #1,INT_CFDATA0         ;  0x38  0xFF70   1   no   ivVxst1         unused by PE 
        MOVB    #1,INT_CFDATA1         ;  0x39  0xFF72   1   no   ivVxst0         unused by PE 
        MOVB    #1,INT_CFDATA2         ;  0x3A  0xFF74   1   no   ivVpit3         unused by PE 
        MOVB    #1,INT_CFDATA3         ;  0x3B  0xFF76   1   no   ivVpit2         unused by PE 
        MOVB    #1,INT_CFDATA4         ;  0x3C  0xFF78   1   no   ivVpit1         unused by PE 
        MOVB    #1,INT_CFDATA5         ;  0x3D  0xFF7A   1   no   ivVpit0         unused by PE 
        MOVB    #1,INT_CFDATA6         ;  0x3E  0xFF7C   1   -    ivVhti          unused by PE 
        MOVB    #1,INT_CFDATA7         ;  0x3F  0xFF7E   1   no   ivVapi          unused by PE 
        MOVB    #128,INT_CFADDR                                        
        MOVB    #1,INT_CFDATA0         ;  0x40  0xFF80   1   no   ivVlvi          unused by PE 
        MOVB    #1,INT_CFDATA1         ;  0x41  0xFF82   1   no   ivVReserved62   unused by PE 
        MOVB    #1,INT_CFDATA2         ;  0x42  0xFF84   1   no   ivVsci5         unused by PE 
        MOVB    #1,INT_CFDATA3         ;  0x43  0xFF86   1   no   ivVsci4         unused by PE 
        MOVB    #1,INT_CFDATA4         ;  0x44  0xFF88   1   no   ivVsci3         unused by PE 
        MOVB    #1,INT_CFDATA5         ;  0x45  0xFF8A   1   no   ivVsci2         unused by PE 
        MOVB    #1,INT_CFDATA6         ;  0x46  0xFF8C   1   no   ivVpwmesdn      unused by PE 
        MOVB    #1,INT_CFDATA7         ;  0x47  0xFF8E   1   no   ivVportp        unused by PE 
        MOVB    #144,INT_CFADDR                                        
        MOVB    #1,INT_CFDATA0         ;  0x48  0xFF90   1   no   ivVcan4tx       unused by PE 
        MOVB    #1,INT_CFDATA1         ;  0x49  0xFF92   1   no   ivVcan4rx       unused by PE 
        MOVB    #1,INT_CFDATA2         ;  0x4A  0xFF94   1   no   ivVcan4err      unused by PE 
        MOVB    #1,INT_CFDATA3         ;  0x4B  0xFF96   1   no   ivVcan4wkup     unused by PE 
        MOVB    #1,INT_CFDATA4         ;  0x4C  0xFF98   1   no   ivVcan3tx       unused by PE 
        MOVB    #1,INT_CFDATA5         ;  0x4D  0xFF9A   1   no   ivVcan3rx       unused by PE 
        MOVB    #1,INT_CFDATA6         ;  0x4E  0xFF9C   1   no   ivVcan3err      unused by PE 
        MOVB    #1,INT_CFDATA7         ;  0x4F  0xFF9E   1   no   ivVcan3wkup     unused by PE 
        MOVB    #160,INT_CFADDR                                        
        MOVB    #1,INT_CFDATA0         ;  0x50  0xFFA0   1   no   ivVcan2tx       unused by PE 
        MOVB    #1,INT_CFDATA1         ;  0x51  0xFFA2   1   no   ivVcan2rx       unused by PE 
        MOVB    #1,INT_CFDATA2         ;  0x52  0xFFA4   1   no   ivVcan2err      unused by PE 
        MOVB    #1,INT_CFDATA3         ;  0x53  0xFFA6   1   no   ivVcan2wkup     unused by PE 
        MOVB    #1,INT_CFDATA4         ;  0x54  0xFFA8   1   no   ivVcan1tx       unused by PE 
        MOVB    #1,INT_CFDATA5         ;  0x55  0xFFAA   1   no   ivVcan1rx       unused by PE 
        MOVB    #1,INT_CFDATA6         ;  0x56  0xFFAC   1   no   ivVcan1err      unused by PE 
        MOVB    #1,INT_CFDATA7         ;  0x57  0xFFAE   1   no   ivVcan1wkup     unused by PE 
        MOVB    #176,INT_CFADDR                                        
        MOVB    #1,INT_CFDATA0         ;  0x58  0xFFB0   1   no   ivVcan0tx       unused by PE 
        MOVB    #1,INT_CFDATA1         ;  0x59  0xFFB2   1   no   ivVcan0rx       unused by PE 
        MOVB    #1,INT_CFDATA2         ;  0x5A  0xFFB4   1   no   ivVcan0err      unused by PE 
        MOVB    #1,INT_CFDATA3         ;  0x5B  0xFFB6   1   no   ivVcan0wkup     unused by PE 
        MOVB    #1,INT_CFDATA4         ;  0x5C  0xFFB8   1   no   ivVflash        unused by PE 
        MOVB    #1,INT_CFDATA5         ;  0x5D  0xFFBA   1   no   ivVflashfd      unused by PE 
        MOVB    #1,INT_CFDATA6         ;  0x5E  0xFFBC   1   no   ivVspi2         unused by PE 
        MOVB    #1,INT_CFDATA7         ;  0x5F  0xFFBE   1   no   ivVspi1         unused by PE 
        MOVB    #192,INT_CFADDR                                        
        MOVB    #1,INT_CFDATA0         ;  0x60  0xFFC0   1   no   ivViic0         unused by PE 
        MOVB    #1,INT_CFDATA1         ;  0x61  0xFFC2   1   no   ivVsci6         unused by PE 
        MOVB    #1,INT_CFDATA2         ;  0x62  0xFFC4   1   no   ivVcrgscm       unused by PE 
        MOVB    #1,INT_CFDATA3         ;  0x63  0xFFC6   1   no   ivVcrgplllck    unused by PE 
        MOVB    #1,INT_CFDATA4         ;  0x64  0xFFC8   1   no   ivVectpabovf    unused by PE 
        MOVB    #1,INT_CFDATA5         ;  0x65  0xFFCA   1   no   ivVectmdcu      unused by PE 
        MOVB    #1,INT_CFDATA6         ;  0x66  0xFFCC   1   no   ivVporth        unused by PE 
        MOVB    #1,INT_CFDATA7         ;  0x67  0xFFCE   1   no   ivVportj        unused by PE 
        MOVB    #208,INT_CFADDR                                        
        MOVB    #1,INT_CFDATA0         ;  0x68  0xFFD0   1   no   ivVatd1         unused by PE 
        MOVB    #1,INT_CFDATA1         ;  0x69  0xFFD2   1   no   ivVatd0         unused by PE 
        MOVB    #1,INT_CFDATA2         ;  0x6A  0xFFD4   1   no   ivVsci1         unused by PE 
        MOVB    #1,INT_CFDATA3         ;  0x6B  0xFFD6   1   no   ivVsci0         used by PE 
        MOVB    #1,INT_CFDATA4         ;  0x6C  0xFFD8   1   no   ivVspi0         unused by PE 
        MOVB    #1,INT_CFDATA5         ;  0x6D  0xFFDA   1   no   ivVectpaie      unused by PE 
        MOVB    #1,INT_CFDATA6         ;  0x6E  0xFFDC   1   no   ivVectpaaovf    unused by PE 
        MOVB    #7,INT_CFDATA7         ;  0x6F  0xFFDE   1   no   ivVectovf       unused by PE 
        MOVB    #224,INT_CFADDR                                        
        MOVB    #1,INT_CFDATA0         ;  0x70  0xFFE0   1   no   ivVectch7       unused by PE 
        MOVB    #4,INT_CFDATA1         ;  0x71  0xFFE2   4   no   ivVectch6       unused by PE 
        MOVB    #4,INT_CFDATA2         ;  0x72  0xFFE4   4   no   ivVectch5       unused by PE 
        MOVB    #1,INT_CFDATA3         ;  0x73  0xFFE6   1   no   ivVectch4       unused by PE 
        MOVB    #1,INT_CFDATA4         ;  0x74  0xFFE8   1   no   ivVectch3       unused by PE 
        MOVB    #1,INT_CFDATA5         ;  0x75  0xFFEA   1   no   ivVectch2       unused by PE 
        MOVB    #1,INT_CFDATA6         ;  0x76  0xFFEC   1   no   ivVectch1       unused by PE 
        MOVB    #1,INT_CFDATA7         ;  0x77  0xFFEE   1   no   ivVectch0       unused by PE 
        MOVB    #240,INT_CFADDR                                        
        MOVB    #1,INT_CFDATA0         ;  0x78  0xFFF0   1   no   ivVrti          unused by PE 
        MOVB    #1,INT_CFDATA1         ;  0x79  0xFFF2   1   no   ivVirq          used by PE 
  ; ### Init_ECT 
        MOVB    #10001000B,ECT_TSCR1  ;TIMER ENABLE; PRECISION TIMER ON
        CLR     ECT_TIE               ;PAS D'INTER                                
        MOVB    #128,ECT_TSCR2        ;ACTIVE INTER OVERFLOW                                              
        MOVB    #128,ECT_TFLG2        ;DEMASQUE L'INTER OF                                  
        MOVB    #9,ECT_PTPSR          ;PRESCALER : 10                                      
        CLR     ECT_PTMCPSR           ;1COUNT=1s OVERFLOW=65,536ms                                      
        MOVB    #$FF,ECT_OCPD         ;DECONNECT OC PIN LOGIC                                
        MOVB    #01100000B,ECT_TIOS   ;CH5 ET CH6 EN OC LES AUTRES EN IC                                      

;        MOVB    #01100000B,ECT_TIE      . A UTILISERPOUR ACTIVER INTER OC6 ET OC5                                  
;        MOVB    #01100000B,ECT_TFLG1    ; A UTILISERPOUR ACTIVER INTER OC6 ET OC5                                    

  ; ### Init_GPIO init code 
		LDAA	#%11111101
		STAA	DDRA
        BCLR    DDRB,00001111B ;PORTB0-3 EN ENTREE
        BSET    PUCR,00000011B ;PULL-UP ON PORTB et PORTA
  ; ### Init_SCI init code 
        ; SCI0CR2: TIE=0,TCIE=0,RIE=0,ILIE=0,TE=0,RE=0,RWU=0,SBK=0 
        CLR      SCI0CR2                ; Disable the SCI0 module 
        LDAA     SCI0SR1               ; Dummy read of the SCI0SR1 registr to clear flags 
        LDAA     SCI0DRL               ; Dummy read of the SCI0DRL registr to clear flags 
        ; SCI0SR2: AMAP=0,TXPOL=0,RXPOL=0,BRK13=0,TXDIR=0,RAF=0 
        CLR     SCI0SR2                                               
        ; SCI0BD: IREN=0,TNP1=0,TNP0=0,SBR12=0,SBR11=0,SBR10=0,SBR9=0,SBR8=0,SBR7=0,SBR6=0,SBR5=1,SBR4=0,SBR3=0,SBR2=0,SBR1=0,SBR0=1 
        MOVW    #33,SCI0BD     ;19200BD                                    
        ; SCI0CR1: LOOPS=0,SCISWAI=0,RSRC=0,M=0,WAKE=0,ILT=0,PE=0,PT=0 
        CLR     SCI0CR1                                               
        ; Switch to the alternative register set
        ; SCI0SR2: AMAP=1 
        BSET    SCI0SR2,128
        ; SCI0ASR1: RXEDGIF=1,BERRV=0,BERRIF=1,BKDIF=1 
        MOVB    #131,SCI0ASR1          ; Clear interrupt flags 
        ; SCI0ACR1: RXEDGIE=0,BERRIE=0,BKDIE=0 
        CLR     SCI0ACR1                                               
        ; SCI0ACR2: BERRM1=0,BERRM0=0,BKDFE=0 
        CLR     SCI0ACR2                                               
        ; Switch to the normal register set
        ; SCI0SR2: AMAP=0 
        BCLR    SCI0SR2,128
        ; SCI0CR2: TIE=0,TCIE=0,RIE=0,ILIE=0,TE=1,RE=1,RWU=0,SBK=0 
        MOVB    #12,SCI0CR2                                        
  ; ### Init_IRQ init code 
        ; IRQCR: IRQE=1,IRQEN=1 
        MOVB    #192,IRQCR                                        
  ; ### 
  ; ### INTER ON RISING EDGE ON PP0 
        MOVB    #1,PIFP                 ;CLEAR FLAG                       
        BSET    PPSP,00000001B			;RISING
        MOVB    #11111100B,PERP			;NO PULL DEVICE ON 0 - 1
        BCLR    DDRP,00000011B			;0 ET 1 INPUT
        MOVB    #1,PIEP                 ;ENABLE                     
  ; ### 

  ; Initial interrupt priority 
        PSHA
        LDAA #0
        TFR A,CCRH
        PULA
        CLI                            ; Enable interrupts 
        RTC

;** ===================================================================
;**     Interrupt handler : isr_default
;**
;**     Description :
;**         User interrupt service routine. 
;**     Parameters  : None
;**     Returns     : Nothing
;** ===================================================================
        XDEF    isr_default
isr_default:

        RTI
; end of isr_default 




;** ===================================================================
;**     Interrupt handler : isrVectovf
;**
;**     Description :
;**         INTERRUPTION POUR OVERFLOW DE TCNT 
;**     Parameters  : None
;**     Returns     : Nothing
;** ===================================================================
        XDEF    isrVectovf
isrVectovf:
 	BSET	ECT_TFLG2,10000000B	;REACTIVE L'INTER POUR LA PROCHAINE FOIS
	INC	OF1
        RTI
; end of isrVectovf 



;** ===================================================================
;**     Interrupt handler : isrVectch6
;**
;**     Description :
;**         ARRETE LA CORRECTION SUR AD+ 
;**     Parameters  : None
;**     Returns     : Nothing
;** ===================================================================
        XDEF    isrVectch6
isrVectch6:
       	TST	  OVERFLOW
      	BNE	  JTOC21
      	CLR	  CORRFLG
      	BSET	PORTA,01000000B   	;AD+ INACTIF
      	BCLR	ECT_TIE,01000000B   	;DESACTIVE L'INTER (FIN DE LA CORRECTION)
      	RTI
JTOC21	DEC	  OVERFLOW
JTOC22	BSET	ECT_TFLG1,01000000B 	;REACTIVE L'INTER (LA CORRECTION N'EST PAS FINIE)

        RTI
; end of isrVectch6 


;** ===================================================================
;**     Interrupt handler : isrVectch5
;**
;**     Description :
;**         ARRETE LA CORRECTION SUR AD- 
;**     Parameters  : None
;**     Returns     : Nothing
;** ===================================================================
        XDEF    isrVectch5
isrVectch5:
       	TST 	OVERFLOW
      	BNE 	JTOC31
      	CLR 	CORRFLG
       	BSET	PORTA,00100000B		;AD- INACTIF
      	BCLR	ECT_TIE,00100000B  	;DESACTIVE L'INTER (FIN DE LA CORRECTION)
      	RTI
JTOC31	DEC 	OVERFLOW
JTOC32	BSET	ECT_TFLG1,00100000B	;REACTIVE L'INTER (LA CORRECTION N'EST PAS FINIE)

        RTI
; end of isrVectch5 



;** ===================================================================
;**     Interrupt handler : isrVportp
;**
;**     Description : 
;**         CHANGEMENT D'ETAT DE LA PHASE 1 DU CODEUR
;**     Parameters  : None
;**     Returns     : Nothing
;** ===================================================================
        XDEF    isrVportp
isrVportp:
  	LDAB	OF1
  	LDY   	ECT_TCNT

	;COMMUTE EDGE DETECTION								;CYCLES CPU
	LDAA	PPSP									;3
	EORA	#00000001B								;1
	STAA	PPSP									;3
	
	;DETERMINATION DU SENS DE ROTATION (1 SEULE FOIS)
	TST	INITSENS								;3
	BNE	JTIC0			;!=0 DEJA INITIALISE				;3
	TST	DELAISDEB
	BNE	JTIC02			;PAS INITIALISABLE : ON SUPOSE POUR LE MOMENT QUE LE SENS ACTUEL EST POSITIF MAIS ON INITIALISE PAS
	LDAA	PORTP
	ANDA	#00000011B
	BEQ	JTIC01
	CMPA	#00000011B
	BEQ	JTIC01
	;SENSCODEUR = 1
	MOVB	#1,SENSCODEUR
	BSET	INITSENS,$FF
	BRA	JTIC02
JTIC01
	;SENSCODEUR = 0	
	MOVB	#0,SENSCODEUR
	BSET	INITSENS,$FF
	BRA	JTIC02

JTIC0	
	;TEST SENS DE ROTATION
	LDAA	PORTP									;3
	ANDA	#00000011B								;1
	BEQ	JTIC04									;3
	CMPA	#00000011B								
	BEQ	JTIC04
	;SENS ACTUEL = 1
	LDAA	#1
	CMPA	SENSCODEUR
	BNE	JTIC03
	BRA	JTIC02
JTIC04
	;SENS ACTUEL = 0	
	LDAA	#0									;1
	CMPA	SENSCODEUR								;3
	BNE	JTIC03									;1
	
JTIC02
	;SENS POSITIF
	MOVB	#0,SENSNEG								;3
	TSTW	COMPTEUR								;4
	BEQ	JTIC10									;3
	DECW	COMPTEUR
	RTI
JTIC03
	;SENS NEGATIF
	MOVB	#1,SENSNEG
	INCW	COMPTEUR
	LDX	#STBY
	CPX	COMPTEUR
	BHI	JTIC10
	BEQ	JTIC05
	RTI
JTIC05
	JSR	RAZ
	CLR	NBINTER1
	RTI
	
	
JTIC10																			;CYCLES CPU:
  	INC 	NBINTER1		;                                             		;4
  	LDAA	#DIVPAS			;                                              		;1
  	CMPA	NBINTER1		;prise en compte de DIVPAS                   		;3
  	BEQ 	JTIC11			;                                                	;3
  	BSET	PIFP,00000001B		;REACTIVE L'INTER POUR LA PROCHAINE FOIS                            
	RTI

JTIC11
	NOP													   							 	;1
	NOP													   							 	;1
	NOP													   							 	;1
	NOP                                                                              	;1
	NOP                                                                              	;1
	NOP                                                                              	;1
	NOP                                                                              	;1
	NOP                                                                              	;1
	NOP                                                                              	;1
	NOP                                                                         		;1
	NOP                                                                            		;1
	NOP                                                                            		;1
	LDAA	OF1                                                                    		;1
	STAA	OFS1                                                                   		;1
	CLR  	OF1		  	;ON VIDE OF1         		                  	SOMME = 60



	CPY 	#$FFFA
	BLO 	JTIC1100
	INC  	OF1	      		;ON RATTRAPPE UN OF QUI S'EST PRODUIT ENTRE LE DEBUT DE L'INTER ET LE MOMENT OU
   	DEC		OFS1           	;ON A VIDE OF1

JTIC1100
	; CPY  	#0
	; BNE  	JTIC1101
;	CMPB  	OF1
;	BEQ  	JTIC1101
;	INCB             	;ON PREND EN COMPTE UN OF QUI S'EST PRODUIT ENTRE LES DEUX PREMIERE INSTRUCTION
                     		;DE CETTE INTER (  LDAB	OF1  et LDY   ECT_TCNT )

JTIC1101
	; STY  	TCNT 
	; STAB	TMPB1   
	BSET	PIFP,00000001B	;REACTIVE L'INTER POUR LA PROCHAINE FOIS                         
 

;CALCUL DE L'INTERVAL ENTRE (TCNT,TMPB1)NOUVELLE VALEURE ET (UNITS1,OFSS1)ANCIENNE

	STY	UNIT1
	LDD	UNIT1
	CPD	UNITS1
	BLO	JTIC111

	SUBD	UNITS1			;LA NOUVELLE VALEURE DE TCNT EST PLUS GRANDE
	XGDY
	BRA	JTIC112
JTIC111					;LA NOUVELLE VALEURE DE TCNT EST PLUS PETITE 
	LDD	#$FFFF
	SUBD	UNITS1
	ADDD	UNIT1
	DEC	OFS1
	XGDY	

JTIC112

	LDD	UNIT1
	STD	UNITS1
	STY	UNIT1			;*** UNIT1 ET OFS1 CONTIENNENT L'INTERVALE MESURE ***


	LDAB	OFS1

	
JTICD				;*** UNIT1 ET OFS1 CONTIENNENT L'INTERVALE MESURE ***

;********************************************************TEST SI POINTAGE EN COUR --- MOD_DETECT = STANDARD
 IF MOD_DETECT==2
	BRSET	PORTA,00000010B,JTIC119
 ENDIF
 IF (MOD_DETECT==2 || MOD_DETECT==0)
		TST	GOTO_CNT
		BEQ	JTIC11C
		DEC	GOTO_CNT
		JSR 	RAZ
		LDAA	#STBY
		STAA	DELAISDEB   ;ON IGNORE LES X CORRECTIONS SUIVANTES
		RTI

JTIC11C										;CETTE PARTIE EST EXECUTEE 
	  IF (NBPAS/DIVPAS) < 165000						;LORSQUE GOTO_CNT==0 ON N'UTILISE 
										;PAS GOTO_FLG EN MODE STANDARD
		IF	((VRTH/8)!=0)                               		;
			LDAA	#(VRTH/8)					;
		ELSE								;
			LDAA	#1						;
		ENDIF								;
										;						
			CMPA	OFS1                                           	;
			BLO 	JTIC1111	;PAS DE POINTAGE                ;
	  ELSE                                                                  ;    
										;
		LDAA	OFS1                                                    ;             
		BNE 	JTIC1111		;SI OF2!=0 PAS DE POINTAGE      ;                       
		LDD	UNIT1                                                   ;              
		CPD 	#((VRT)/8)                                             	;
		BHS 	JTIC1111    		;PAS DE POINTAGE                ;                                  
	  ENDIF									;
                                                                                ;             
  	      								;	;CETTE PARTIE EST EXECUTEE
  	JSR 	RAZ								;	;LORSQUE L'INTERVALE EST AU
  	LDAA	#STBY								;	;MOINS 8 FOIS PLUS COURT QUE
  	STAA	DELAISDEB   ;ON IGNORE LES X CORRECTIONS SUIVANTES		;	;VRT (c.a.d. POINTAGE)
										;	;
   	RTI									;	;
 ENDIF	

JTIC119

;******************************************************** fin du test --- MOD_DETECT = STANDARD

;********************************************************TEST SI POINTAGE EN COUR --- MOD_DETECT = LOGICIEL
 IF MOD_DETECT==2
	BRCLR	PORTA,00000010B,JTIC11A
 ENDIF
 IF (MOD_DETECT==2 || MOD_DETECT==1)
	TST	GOTO_FLG		;EN MODE LOGICIEL ON TEST UNIQUEMENT GOTO_FLG POUR SAVOIR SI IL Y A POINTAGE
	BEQ	JTIC1111
	TST	GOTO_CNT
	BEQ	JTIC11B
	DEC	GOTO_CNT
	JSR 	RAZ
	RTI

JTIC11B

	LDAA	SENSNEG			;SI LE SENS EST NEGATIF, LE POINTAGE N'EST PAS FINI
	BEQ	JTIC11F
	LDAA	#2
	STAA	GOTO_CNT

									;CETTE PARTIE EST EXECUTEE LORSQUE GOTO_FLG==1 
JTIC11F	LDAA	OFS1							;ET QUE GOTO_CNT==0, ON ATTEND D'AVOIR UN 
	CMPA	REFOF							;INTERVAL > A REF POUR DETERMINER QUE LE POINTAGE
	BHI		JTIC11E						;EST FINI ET METTRE GOTO_FLG A 0
	BNE		JTIC11D						;
	LDD		UNIT1						;
	CPD		REF						;
	BHS		JTIC11E						;
	BRA	JTIC11D							;
JTIC11E	CLR	GOTO_FLG						;
JTIC11D	RTI								;
 ENDIF	

JTIC11A


;******************************************************** fin du test --- MOD_DETECT = LOGICIEL
JTIC1111
;******************************************************** test SI ORDRE RAQUETTE LOGICIEL 
	TST	RAQUETTE_FLG
	BEQ	JTIC1111A
  	JSR 	RAZ
   	RTI
;******************************************************** fin du test RAQUETTE


	LDAA	SENSNEG
	BEQ	JTIC1111A
	RTI			;SI LE SENS EST NEGATIF ON NE CORRIGE PAS




;*********************CORRECTION*************************************

JTIC1111A
  	; CALCUL DE LA DIFFERENCE AVEC LA VALEURE DE REF
  	LDAA	REFOF
  	CMPA	OFS1
  	BLO 	JTIC113
  	BEQ 	JTIC114
  					;REFOF EST SUPERIEUR => LA MONTURE VA TROP VITE 
  	LDAA	#1			;SENS AD-
  	LDAB	REFOF
  	SUBB	OFS1
  	LDY 	REF
  	SUBY	UNIT1
  	BCC 	JTIC118
  	DECB
  	BRA 	JTIC118

JTIC113				  	;REFOF EST INFERIEUR => LA MONTURE VA TROP LENTEMENT
  	LDAA	#0			;SENS AD+
  	LDAB	OFS1
  	SUBB	REFOF
  	LDY 	UNIT1
  	SUBY	REF
  	BCC 	JTIC118
  	DECB
  	BRA 	JTIC118

JTIC114				  	;REFOF EST EGAL => ON TEST UNIT1
  	CPY 	REF
  	BLO 	JTIC117
  			      		;REF EST INFERIEUR OU EGAL => LA MONTURE VA TROP LENTEMENT
  	LDAA	#0			;SENS AD+
  	LDAB	#0
  	LDY 	UNIT1
  	SUBY	REF
  	BRA 	JTIC118
JTIC117				  	;REF EST SUPERIEUR => LA MONTURE VA TROP VITE 
  	LDAA	#1			;SENS AD-
  	LDAB	#0
  	LDY 	REF
  	SUBY	UNIT1
  	
JTIC118



JTIC1182
	;A=SENS B=OF Y=UNIT
	;ON CUMULE
		JSR 	CUMUL1			;RENVOI LE CUMUL
		JSR 	CORRIGE			;ON CORRIGE SUR LE CUMUL 
		CLR		NBINTER1
        RTI
; end of isrVportp 



;** ===================================================================
;**     Interrupt handler : isrVtimch0
;**
;**     Description :
;**          
;**     Parameters  : None
;**     Returns     : Nothing
;** ===================================================================
        XDEF    isrVtimch0
isrVtimch0:
    RTI
; end of isrVtimch0 


;** ===================================================================
;**     Interrupt handler : isrVsci0
;**
;**     Description :
;**         User interrupt service routine. 
;**     Parameters  : None
;**     Returns     : Nothing
;** ===================================================================
        XDEF    isrVsci0
isrVsci0:

        RTI
; end of isrVsci0 


;** ===================================================================
;**     Interrupt handler : isrVirq
;**
;**     Description :
;**         INTERRUPTION POUR DECTION DU PASSAGE A ZERO ( ** pour dvloppements  venir ** ) 
;**     Parameters  : None
;**     Returns     : Nothing
;** ===================================================================
        XDEF    isrVirq
isrVirq:
      	LDY	#0
      	STY	POS

        RTI
; end of isrVirq 




_code_curPos:   EQU     *              ; remember original position of code for restoring at the end of the file

; Initialization of the CPU registers in FLASH 




; Interrupt vector table 

  ifndef UNASSIGNED_ISR
UNASSIGNED_ISR:    EQU     isr_default ; unassigned interrupt service routine
  endif
        ORG     $FF10                  ; Interrupt vector table
_vect:
                ; ISR name                  No.  Address Pri XGATE Name            Description 
        DC.W    UNASSIGNED_ISR           ; 0x08  0xFF10   -   -    ivVsi           unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x09  0xFF12   -   -    ivVsyscall      unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x0A  0xFF14   -   -    ivVmpuaccesserr unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x0B  0xFF16   -   no   ivVxsei         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x0C  0xFF18   1   no   ivVReserved115  unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x0D  0xFF1A   1   no   ivVReserved114  unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x0E  0xFF1C   1   no   ivVReserved113  unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x0F  0xFF1E   1   no   ivVReserved112  unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x10  0xFF20   1   no   ivVReserved111  unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x11  0xFF22   1   no   ivVReserved110  unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x12  0xFF24   1   no   ivVReserved109  unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x13  0xFF26   1   no   ivVReserved108  unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x14  0xFF28   1   no   ivVReserved107  unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x15  0xFF2A   1   no   ivVReserved106  unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x16  0xFF2C   1   no   ivVReserved105  unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x17  0xFF2E   1   no   ivVReserved104  unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x18  0xFF30   1   no   ivVReserved103  unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x19  0xFF32   1   no   ivVReserved102  unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x1A  0xFF34   1   no   ivVReserved101  unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x1B  0xFF36   1   no   ivVReserved100  unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x1C  0xFF38   1   no   ivVReserved99   unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x1D  0xFF3A   1   no   ivVReserved98   unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x1E  0xFF3C   1   no   ivVatd1compare  unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x1F  0xFF3E   1   no   ivVatd0compare  unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x20  0xFF40   1   no   ivVtimpaie      used by PE 
        DC.W    UNASSIGNED_ISR           ; 0x21  0xFF42   1   no   ivVtimpaaovf    used by PE 
        DC.W    UNASSIGNED_ISR           ; 0x22  0xFF44   1   no   ivVtimovf       used by PE 
        DC.W    UNASSIGNED_ISR           ; 0x23  0xFF46   1   no   ivVtimch7       unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x24  0xFF48   1   no   ivVtimch6       unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x25  0xFF4A   1   no   ivVtimch5       unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x26  0xFF4C   1   no   ivVtimch4       unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x27  0xFF4E   1   no   ivVtimch3       used by PE 
        DC.W    UNASSIGNED_ISR           ; 0x28  0xFF50   2   no   ivVtimch2       used by PE 
        DC.W    UNASSIGNED_ISR           ; 0x29  0xFF52   1   no   ivVtimch1       unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x2A  0xFF54   2   no   ivVtimch0       used by PE 
        DC.W    UNASSIGNED_ISR           ; 0x2B  0xFF56   1   no   ivVsci7         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x2C  0xFF58   1   no   ivVpit7         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x2D  0xFF5A   1   no   ivVpit6         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x2E  0xFF5C   1   no   ivVpit5         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x2F  0xFF5E   1   no   ivVpit4         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x30  0xFF60   1   no   ivVReserved79   unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x31  0xFF62   1   no   ivVReserved78   unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x32  0xFF64   1   no   ivVxst7         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x33  0xFF66   1   no   ivVxst6         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x34  0xFF68   1   no   ivVxst5         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x35  0xFF6A   1   no   ivVxst4         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x36  0xFF6C   1   no   ivVxst3         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x37  0xFF6E   1   no   ivVxst2         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x38  0xFF70   1   no   ivVxst1         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x39  0xFF72   1   no   ivVxst0         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x3A  0xFF74   1   no   ivVpit3         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x3B  0xFF76   1   no   ivVpit2         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x3C  0xFF78   1   no   ivVpit1         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x3D  0xFF7A   1   no   ivVpit0         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x3E  0xFF7C   1   -    ivVhti          unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x3F  0xFF7E   1   no   ivVapi          unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x40  0xFF80   1   no   ivVlvi          unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x41  0xFF82   1   no   ivVReserved62   unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x42  0xFF84   1   no   ivVsci5         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x43  0xFF86   1   no   ivVsci4         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x44  0xFF88   1   no   ivVsci3         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x45  0xFF8A   1   no   ivVsci2         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x46  0xFF8C   1   no   ivVpwmesdn      unused by PE 
        DC.W    isrVportp                ; 0x47  0xFF8E   1   no   ivVportp        used by PE 
        DC.W    UNASSIGNED_ISR           ; 0x48  0xFF90   1   no   ivVcan4tx       unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x49  0xFF92   1   no   ivVcan4rx       unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x4A  0xFF94   1   no   ivVcan4err      unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x4B  0xFF96   1   no   ivVcan4wkup     unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x4C  0xFF98   1   no   ivVcan3tx       unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x4D  0xFF9A   1   no   ivVcan3rx       unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x4E  0xFF9C   1   no   ivVcan3err      unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x4F  0xFF9E   1   no   ivVcan3wkup     unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x50  0xFFA0   1   no   ivVcan2tx       unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x51  0xFFA2   1   no   ivVcan2rx       unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x52  0xFFA4   1   no   ivVcan2err      unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x53  0xFFA6   1   no   ivVcan2wkup     unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x54  0xFFA8   1   no   ivVcan1tx       unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x55  0xFFAA   1   no   ivVcan1rx       unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x56  0xFFAC   1   no   ivVcan1err      unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x57  0xFFAE   1   no   ivVcan1wkup     unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x58  0xFFB0   1   no   ivVcan0tx       unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x59  0xFFB2   1   no   ivVcan0rx       unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x5A  0xFFB4   1   no   ivVcan0err      unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x5B  0xFFB6   1   no   ivVcan0wkup     unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x5C  0xFFB8   1   no   ivVflash        unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x5D  0xFFBA   1   no   ivVflashfd      unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x5E  0xFFBC   1   no   ivVspi2         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x5F  0xFFBE   1   no   ivVspi1         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x60  0xFFC0   1   no   ivViic0         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x61  0xFFC2   1   no   ivVsci6         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x62  0xFFC4   1   no   ivVcrgscm       unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x63  0xFFC6   1   no   ivVcrgplllck    unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x64  0xFFC8   1   no   ivVectpabovf    unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x65  0xFFCA   1   no   ivVectmdcu      unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x66  0xFFCC   1   no   ivVporth        unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x67  0xFFCE   1   no   ivVportj        unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x68  0xFFD0   1   no   ivVatd1         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x69  0xFFD2   1   no   ivVatd0         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x6A  0xFFD4   1   no   ivVsci1         unused by PE 
        DC.W    isrVsci0                 ; 0x6B  0xFFD6   1   no   ivVsci0         used by PE 
        DC.W    UNASSIGNED_ISR           ; 0x6C  0xFFD8   1   no   ivVspi0         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x6D  0xFFDA   1   no   ivVectpaie      unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x6E  0xFFDC   1   no   ivVectpaaovf    unused by PE 
        DC.W    isrVectovf               ; 0x6F  0xFFDE   7   no   ivVectovf       used by PE 
        DC.W    UNASSIGNED_ISR           ; 0x70  0xFFE0   1   no   ivVectch7       unused by PE 
        DC.W    isrVectch6               ; 0x71  0xFFE2   4   no   ivVectch6       used by PE 
        DC.W    isrVectch5               ; 0x72  0xFFE4   4   no   ivVectch5       used by PE 
        DC.W    UNASSIGNED_ISR           ; 0x73  0xFFE6   1   no   ivVectch4       unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x74  0xFFE8   1   no   ivVectch3       unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x75  0xFFEA   1   no   ivVectch2       unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x76  0xFFEC   1   no   ivVectch1       unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x77  0xFFEE   1   no   ivVectch0       unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x78  0xFFF0   1   no   ivVrti          unused by PE 
        DC.W    isrVirq                  ; 0x79  0xFFF2   1   no   ivVirq          used by PE 
        DC.W    UNASSIGNED_ISR           ; 0x7A  0xFFF4   -   -    ivVxirq         unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x7B  0xFFF6   -   -    ivVswi          unused by PE 
        DC.W    UNASSIGNED_ISR           ; 0x7C  0xFFF8   -   -    ivVtrap         unused by PE 

        ORG     $FFFA                   ; Interrupt vector table
_reset_vect:
                ; Name                    Address Name             Description 
        DC.W    MCU_init_reset          ; 0xFFFA  ivVcop           unused by PE 
        DC.W    MCU_init_reset          ; 0xFFFC  ivVclkmon        unused by PE 
        DC.W    MCU_init_reset          ; 0xFFFE  ivVreset         used by PE 


        ORG     _code_curPos           ; restore original position for code

