;**************************************************************************
;*			****** vos rglages ******
;*
;*	La vitesse de correction de votre monture doit tre rgle
;*	 la vitesse sidrale (ad- : 0 arcsec/s ; ad+ : 30 arcsec/s)
;*
;*	Nombre de dents de votre monture (en ascention droite):
NBDENT	EQU	180	;216
;*
;*	Nombre de pas de votre encoder fois 2 (= nb lignes * interpolation * 2 )
NBPAS	EQU	216000	;180000
;*
;*	Coefficient diviseur (permet de rduire le nb de corrections par rapport au nombre de pas)
;*	Attention NBPAS/DIVPAS doit tre suprieur  5140
DIVPAS	EQU	1
;*
;*	Dure du jour sidral en secondes 
JOURSID	EQU	86164		
;*
;*	Faites le calcul : (JOURSID * 1000000 *  DIVPAS)/NBPAS  notez le resultat si-dessous (le compilateur est limit 
;*	 32bits pour ses calculs, il ne peut donc pas effectuer celui-ci)
VRT	EQU	398907	;478689		
;*	cette valeure est l'interval thorique en seconde entre deux pas de l'encodeur. Si vous constater une drive
;*	(qui peut s'expliquer par l'imprcision des quartz) vous pouvez modifier la valeur VRTADD de la faon suivante:
;* 	pour une drive de x arcsec/sec la valeur VRTADD sera  (x*(VRT+VRTADD))/15.
;*	Cette valeure aura un signe + lorsque la monture va trop vite par rapport au ciel et - dans le cas contraire.
VRTADD	EQU	0
;*
;*
;*	faites le calcul RDM_ROL=partie entiere de [16-( log((NBDENT*DIVPAS*40960)/NBPAS ; 2))]  aidez-vous du fichier excel
RDM_ROL	EQU	10
;*	faites le calcul RDM = arrondi de [(NBDENT*DIVPAS*40960*(2^RDM_ROL))/NBPAS]
RDM	EQU	34953	;50332
;*
;*
;*
;*	detection du pointage:
;*		MOD_DETECT=0 : mode standard, NPEC dtecte les ordres reu par le drivers de MCMTII (goto et raquette logicielle)
;*					      et les ordres de la raquette manuelle ( NPEC se met en veille quand la vitesse est trs eloigne de la vitesse sidrale )
;*		
;*		MOD_DETECT=1 : mode logiciel, NPEC ne dtecte que les ordres reu par le drivers de MCMTII (le ratrapage  la 
;*					      raquette et l'utilisation avec une autre motorisation que MCMTII n'est plus possible)
;*
;*		MOD_DETECT=2 : la selection des deux prcdent modes est ralise par un interrupteur branch entre les  
;*			       pin 3 et 4 du port 'extension1' => inter ferm : standard ; inter ouvert : logiciel
MOD_DETECT EQU	0
;*
;*
;*			****** fin de vos rglages ******
;**************************************************************************
;*	ne pas modifier ce qui suit
 IF ((RDM%$A)>5)
RDM_LSB EQU	(RDM/10)+1
 ELSE
RDM_LSB	EQU	RDM/10
 ENDIF
VRTH	EQU	(VRT+VRTADD)/65536
VRTL	EQU	(VRT+VRTADD)%65536
 IF (10000000/((VRT+VRTADD)*DIVPAS))>=2
STBY	EQU	10000000/((VRT+VRTADD)*DIVPAS)
 ELSE 
STBY	EQU	2
 ENDIF
;**************************************************************************

; export symbols
            XDEF Entry, _Startup            ; export 'Entry' symbol
            ABSENTRY Entry        ; for absolute assembly: mark this as application entry point



; Include derivative-specific definitions 
	    INCLUDE 'derivative.inc' 

ROMStart    EQU  $4000  

            ORG RAMStart
;********************
;*  LES VARIABLES   *
;********************
ASCII		RMB	5
TMPW		RMB	2
TMPDW		RMB	4
TMPB		RMB	1
TMPB1		RMB	1
FLAGS1		RMB	1
CHEKSUM		RMB	1
REF	        RMB	2
REFOF		RMB	1
DELAY_M		RMB	2
DELAY_M_LSB 	RMB	1
GOTO_CNT	RMB	1
GOTO_FLG	RMB	1
RAQUETTE_FLG	RMB	1
OF_TMP    	RMB	1
SCORR1    	RMB	2
SCORROF1  	RMB	1
SCORRSE1  	RMB	1
CORRC1		RMB	2
CORROFC1	RMB	1
CORRSEC1  	RMB	1
OF1       	RMB	1
OFS1      	RMB	1
OFSS1      	RMB	1
UNIT1     	RMB	2
UNITS1     	RMB	2
POS       	RMB	2	;POSITION EN PAS CODEUR
DELAISDEB 	RMB	1
NBIRQ     	RMB	1
NBINTER1  	RMB	1
OVERFLOW  	RMB	1
CORRFLG	  	RMB	1	; DRAPEAU CORRECTION EN COUR
MEMCORR	  	RMB	2	; MISE EN ATTENTE DES CORRECTIONS LORSQU'UNE CORRECTION EST DEJA EN COUR
MEMOVERFLOW	RMB	1	; """"""""""""""""""""OVERFLOW""""""""""""""""""""""""""""""""""""""""""
MEMSENS	  	RMB	1	; """"""""""""""""DU SENS"""""""""""""""""""""""""""""""""""""""""""""""$00=AD+ $01=AD-
BUF       	RMB	9	; BUFFER DE RECEPTION DE LA SCI
CURSEUR   	RMB	1
TCNT		RMB	2
COMPTEUR	RMB	2
COMPTEUR1FLG	RMB	1
INITSENS	RMB	1	;SI !=0 ALORS SENSCODEUR  A DEJA ETE INITIALISE
SENSCODEUR	RMB	1	;SENSCODEUR - DETERMINE LA DIRECTION DU SENS POSITIF : VAUT 0 OU 1
 				;0:AU CHANGEMENT D'ETAT DE LA PHASE1 LES 2 PHASES SONT AU MEME NIVEAU LOGIQUE POUR LE SENS POSITIF
				;1:AU CHANGEMENT D'ETAT DE LA PHASE1 LES 2 PHASES SONT DE NIVEAUX LOGIQUES OPPOSES POUR LE SENS POSITIF
SENSNEG		RMB	1	;0 SI SENS ACTUEL EST POSITIF 1 SI SENS ACTUEL EST NEGATIF


            ORG   ROMStart

; INITIALISATION DU CPU
            INCLUDE 'MCUInit.inc'

Entry:
_Startup:
            LDS   #RAMEnd+1       ; initialize the stack pointer

            ; Call Device Initialization function
            CALL   MCU_init
            
            
            ; INIT SUPPLEMENTAIRES
;*** PORTP - Port P Data Register; 0x00000258 ***
PORTP:              equ    $00000258                                
; bit position masks
BIT0:         equ    %00000001
BIT1:         equ    %00000010
BIT2:         equ    %00000100
BIT3:         equ    %00001000
BIT4:         equ    %00010000
BIT5:         equ    %00100000
BIT6:         equ    %01000000
BIT7:         equ    %10000000

;CONFIGURE LES IO NON UTILISES EN SORTIES (POUR EVITER QU'ELLES FLOTENT)
  LDAA  #$FF
  STAA  DDRJ
  STAA  DDRM
  STAA  DDRT
  LDAA  #%11110000
  STAA  DDRB
  LDAA  #%11111100
  STAA  DDRP
  LDAA  #%11111100
  STAA  DDRS
  LDAA  #%11111110
  STAA  DDR1AD0
  LDAA  #%11111100
  STAA  DDRE
  BSET  PUCR,BIT4
  


            
            
	;ACTIVE INTER OVERFLOW
	BSET	ECT_TFLG2,X,10000000B
	;ACTIVE INTER CODEUR
	BSET	PIFP,X,00000001B



; INITIALISATION DE NPEC


	LDD 	#$0000		;VARIABLES  A 0
	STD 	TMPW
	STAA	TMPB
	STAA	BUF
	STAA	BUF+1
	STAA	BUF+2
	STAA	BUF+3
	STAA	BUF+4
	STAA	BUF+5
	STAA	BUF+6
	STAA	BUF+7
	STAA	OVERFLOW	
	STAA	CORRFLG		
	STAA	MEMCORR		
	STAA	MEMOVERFLOW	
	STAA	MEMSENS	
	STAA	NBIRQ
	STAA	NBINTER1
	LDD 	#VRTL 			 ;VITESSE DE REF
	STD 	REF           		 ;
	LDAA	#VRTH 			 ;
	STAA	REFOF        		 ;
	LDAA	#STBY        ;ON IGNORE x CORRECTIONS
	STAA	DELAISDEB    ;
	LDAA	#0
	STAA	PORTA
	STAA	GOTO_CNT
	STAA	GOTO_FLG
	STAA	RAQUETTE_FLG
	BSET	PORTA,01100000B		;AD- ET + INACTIF
	CLRW	COMPTEUR
	CLR	INITSENS
	CLR	COMPTEUR1FLG



;BOUCLE PRINCIPALE   
      
mainLoop: 
	
	
		TST 	DELAISDEB			;GERE LA LED TEMOIN DE STAND-BY (CONNECTEE SUR PIN2 DU CONNECTEUR EXTENSION1)
		BEQ	ML2				;
		BSET	PORTA,01100000B			;AD- ET + INACTIF
ML1		BSET	PORTA,1				;
		BRA	ML3				;
ML2 		BCLR	PORTA,1         		;	  	
ML3
		LDAA	#1				;COMPTEUR EST EFFACE UNE SEULE FOIS LORSQUE DELAISDEB PASSE A 0
		CMPA	DELAISDEB			;
		BNE	ML6				;
		MOVB 	#$FF,COMPTEUR1FLG		;
		BRA 	ML7				;
ML6		TST	DELAISDEB			;
		BNE	ML7				;DELAISDEB !=0 && !=1
		TST	COMPTEUR1FLG			;
		BEQ	ML7				;
		CLR	COMPTEUR1FLG			;
		CLRW	COMPTEUR			;ON EFFACE COMPTEUR CAR DELAISDEB=0 MAINTENANT ET VALAIT 1 LA FOIS PRECEDANTE


ML7		
    		BRCLR	SCI0SR1,00100000B,ML4  		;RECEPTION RS232
    		BSR 	CHRIN             		;
ML4  		BSR 	TRAITESCI           		;
            
           		                  		;; SI COMMANDES SUR ST4_IN
           			             		;; ON NE RATTRAPE PAS CES 
           			               		;; CORRECTIONS
		BRSET 	PORTB,00000001B,ML5 		;
		LDAA 	#2                      	;
		STAA 	DELAISDEB               	;
ML5		BRSET 	PORTB,00000010B,mainLoop 	;
		LDAA 	#2                      	;
		STAA 	DELAISDEB               	;

		BRA		mainLoop 
            

;FONCTIONS

;**********
;*  OUTSCI() - Output A to sci.
;*               
;**********
OUTSCI   PSHB
OUTSCI2  LDAB 	SCI0SR1      		;read status
         BITB 	#$80
         BEQ  	OUTSCI2     		;loop until tdre=1
         STAA 	SCI0DRL      		;send character
      	 PULB
	     RTS
	       
;******************
;*CHRIN()
;*   RECOIT LE BYTE DE LA SCI ET LE MET DANS LE BUFER
;******************
CHRIN   PSHA
    	  PSHB
CHRIN1	LDAA	SCI0SR1		; Load A with the SCI status register
      	ANDA	#$20	  	; AND it with the RDRF mask
      			          	;   (receive data register full)
      	BEQ 	CHRIN1		; branch  if RDRF is zero
      	LDAA	SCI0DRL		; Load A with SCI0DRL, the SCI Data Register


	
		CMPA	#$70		;test rapide si pointage demand pour stoper la correction en cours le 
		BNE	CHRIN2		;plus vite possible
		LDAB	BUF+$07		;
		CMPB	#$E0		;
		BNE	CHRIN2		;
		BSET	PORTA,01100000B	;AD- ET + INACTIF
		INC 	DELAISDEB	;	



CHRIN2 	LDAB	BUF+$01 	;DECALE LE BUFFER DE 1 VERS LA GAUCHE
      	STAB	BUF	     	;
      	LDAB	BUF+$02  	;
      	STAB	BUF+$01 	;
      	LDAB	BUF+$03	  	;
      	STAB	BUF+$02  	;
      	LDAB	BUF+$04	  	;
      	STAB	BUF+$03	  	;
      	LDAB	BUF+$05	  	;
      	STAB	BUF+$04	  	;
      	LDAB	BUF+$06	 	;
      	STAB	BUF+$05	  	;
      	LDAB	BUF+$07	  	;
      	STAB	BUF+$06	  	;
      	STAA	BUF+$07	  	;STOQUE LA VALEURE LUE
      	PULB
      	PULA
      	RTS
	
;***********************
;*TRAITESCI()
;* LIT LES OCTETS RECUS ET AGIT EN CONCEQUENCE
;***********************
		
TRAITESCI
    	PSHA
    	LDAA	BUF
    	CMPA	#$E0		;AD
    	BEQ  	TRAITESCI0
    	CMPA	#$E3		;
		BNE	TRAITESCI00
		LDAA	BUF+1
		CMPA	#$AA
		BNE	TRAITESCI00
		CLR	RAQUETTE_FLG
TRAITESCI00
		PULA
    	RTS

TRAITESCI0
	PSHB
    	PSHY
	;VERIFICATION DE LA VALIDITE DE L'ORDRE
    	LDAA	#0 
    	LDY 	#0
    	LDAB	#7
TRAITESCI1
	ADDA	BUF,Y
	INY
	DECB
	BNE 	TRAITESCI1

    	ANDA	#01111111B
    	CMPA	BUF+7
	BEQ	TRAITESCI02
    	PULY
    	PULB
    	PULA
    	RTS

TRAITESCI02	;LECTURE DE L'ORDRE
    	LDAA	BUF+1
    	CMPA	#$52		;R  Ecriture Valeur DELAY_M, DELAY_M_LSB et Dir_M
    	BEQ 	TRAITESCI01
    	CMPA	#$70		;p  POSITIONNEMENT
    	BEQ 	TRAITESCI002     
    	CMPA	#$44		;D  Correction +
    	BEQ 	TRAITESCI003
    	CMPA	#$46		;F  Lent -
    	BEQ 	TRAITESCI003
    	CMPA	#$47		;G  Lent +
    	BEQ 	TRAITESCI003
    	CMPA	#$51		;Q  Correction -
    	BEQ 	TRAITESCI003
    	CMPA	#$57		;W  Rapide -
    	BEQ 	TRAITESCI003
    	CMPA	#$58		;X  Rapide +
    	BEQ 	TRAITESCI003
    	CMPA	#$53		;S  VITESSE SIDERALE
    	BEQ 	TRAITESCI004
    	CMPA	#$72		;r  LECTURE Valeur DELAY_M, DELAY_M_LSB, PEC_BASE, PEC_STEP, PEC_COMP, PEC_STATE et Park
    	BEQ 	TRAITESCI004
	PULY
	PULB
    	PULA
    	RTS


TRAITESCI002		;POINTAGE DEMANDE => ON DESACTIVE NPEC
	BSET	PORTA,01100000B		;AD- ET + INACTIF
	LDAA	#STBY
	STAA	GOTO_CNT
	LDAA	#$FF
	STAA	GOTO_FLG
	LDAA	#STBY        		;ON IGNORE x CORRECTIONS
	STAA	DELAISDEB    		;
	PULY
	PULB
	PULA
	RTS
TRAITESCI003		;CORRECTION DEMANDE => ON DESACTIVE NPEC
	BSET	PORTA,01100000B		;AD- ET + INACTIF
	LDAA	#$FF
	STAA	RAQUETTE_FLG
	MOVB	#2,DELAISDEB
	PULY
	PULB
	PULA
	RTS
TRAITESCI004		;FIN DE CORRECTION DEMANDE => ON REACTIVE NPEC
	
	CLR	RAQUETTE_FLG
	PULY
	PULB
	PULA
	RTS


TRAITESCI01


	CLR	RAQUETTE_FLG

      				;MISE EN FORME DES 4 BYTES DE DONNEE AVEC LE BYTE 6 QUI CONTIENT LES BITS DE POIDS FORT DES AUTRES BYTES
    	LDY 	#0
    	BRCLR	BUF+6,Y,00000001B,TRAITESCI2
    	BSET	BUF+5,Y,10000000B
TRAITESCI2
    	BRCLR	BUF+6,Y,00000010B,TRAITESCI3
    	BSET	BUF+4,Y,10000000B
TRAITESCI3
    	BRCLR	BUF+6,Y,00000100B,TRAITESCI4
    	BSET	BUF+3,Y,10000000B
TRAITESCI4
    	BRCLR	BUF+6,Y,00001000B,TRAITESCI5
    	BSET	BUF+2,Y,10000000B
TRAITESCI5
    				;TRAITEMENT DE L'ORDRE RECU: MISE A JOUR DE LA VITESSE DE REFERENCE
	LDD	BUF+2
	STD	DELAY_M
	LDAA	BUF+4
	STAA	DELAY_M_LSB
    	BSR 	VIT
    				;VIDAGE DU BUFFER
    	LDD	#0
    	STD	BUF
    	STD	BUF+2
    	STD	BUF+4
    	STD	BUF+6
	

    	PULY
    	PULB
    	PULA
    	RTS

;***********************
;*VIT()
;* MET A JOUR LA VITESSE DE SUIVI 
;* A PARTIR DES VALEURES RECUES PAR LA SCI
;*
;***********************
VIT
    	PSHA
    	PSHB
    	PSHY
	;on multipie le delais MCMTII par le ratio RDM = resultat 32 bits dans TMPDW
	LDY	#RDM
	LDD	DELAY_M
	EMUL
	STY	TMPDW
	STD	TMPDW+2

	LDY	#RDM_LSB
	LDAA	#0
	LDAB	DELAY_M_LSB
	EMUL
	ADDD	TMPDW+2
	ADEY	TMPDW
	;on rduit de RDM_ROL bits le rsultat pour tomber sur VRT
	LDX	#RDM_ROL
VIT1	BEQ	VIT2
	ROR	TMPDW
	ROR	TMPDW+1
	ROR	TMPDW+2
	ROR	TMPDW+3
	CLC
	DEX
	BRA	VIT1
	;on met a jour le delais NPEC
VIT2	LDD	TMPDW+2
	STD	REF
	LDAA	TMPDW+1
	STAA	REFOF
	
    	PULY
    	PULB
    	PULA
    	RTS

;**********
;*RAZ() REMISE A ZERO 
;**********
RAZ
  	CLR	OF1											;**********************changement
	; MOVW	ECT_TCNT,UNITS1
	; MOVB	OF1,OFS1
  	CLRW 	SCORR1
  	CLR	SCORRSE1
  	CLR	SCORROF1	
  	CLRW 	CORRC1
  	CLR	CORROFC1
  	CLR	CORRSEC1	
  	CLRW 	MEMCORR
  	CLR	MEMOVERFLOW
  	CLR	MEMSENS	
  	RTS

;**********
;*   CORRIGE() - EFFECTUE UNE CORRECTION DE SUIVI SUR AD
;*
;* "Y" unchanged, VALEUR DE CORRECTION (MODULO $10000)  
;* "A" unchanged, SENS	$00=AD+	 $01=AD-
;* "B" unchanged, NOMBRE D'OVERFLOW  A PRENDRE EN COMPTE
;**********
CORRIGE	PSHX
      	PSHY
      	PSHA
      	PSHB
      	TST 	DELAISDEB
      	BEQ 	CORR0
      	DEC 	DELAISDEB
      	BSR 	RAZ
      	BRA 	CORR3			;ON SORT SANS RIEN FAIRE
CORR0
        TST 	CORRFLG	
     	BNE 	CORR3 			
;	JSR	MEMCORRIGE 											;**********************changement
;	BRA	CORR3			;SI CORRECTION EN COURS ON SORT

CORR01
	; JSR	AJOUTEMEM
	; CLRW	MEMCORR
	; CLR	MEMOVERFLOW
	; CLR	MEMSENS

  	; CMPB	#10		    	;PAS DE CORRECTION TROP LONGUE
  	; BLO 	CORR4			;	
  	; LDAB	#10		  	;

CORR4	STAB	OVERFLOW
      	LDAB	#$FF
      	STAB	CORRFLG			;ACTIVE LE DRAPEAU
      	CMPA	#0
      	BNE 	CORR2
CORR1 	XGDY
CORR1A	BCLR	PORTA,01000000B		;AD+ ACTIF
      	ADDD	ECT_TCNT		;ON ACTIVE
      	STD 	ECT_TC2			;LE TIMER 
      	BSET	ECT_TFLG1,01000000B	;
      	BSET	ECT_TIE,01000000B	;
      	BRA 	CORR3
CORR2 	XGDY
CORR2A	BCLR	PORTA,00100000B		;AD- ACTIF
      	ADDD	ECT_TCNT		;ON ACTIVE
      	STD 	ECT_TC3			;LE TIMER
      	BSET	ECT_TFLG1,00100000B	;
      	BSET	ECT_TIE,00100000B	;

CORR3
CORR6 	PULB
      	PULA
      	PULY
      	PULX
CORR7	RTS

;******************
;*CUMUL1()	CUMULE LA CORRECTION DANS CORRC1, CORROFC1, CORRSEC1 
;*   RENVOIS LE CUMUL SUR A, B, ET Y
;*
;* "Y" VALEUR DE CORRECTION  
;* "A" SENS	$00=AD+	 $01=AD-
;* "B" NOMBRE D'OVERFLOW A PRENDRE EN COMPTE
;******************
CUMUL1
	;COPIE DE SAUVEGARDE DE MEMCORR ETC
	; MOVW	MEMCORR,TMPW		;
	; MOVB	MEMOVERFLOW,TMPB	;
	; MOVB	MEMSENS,TMPB1		;
	
	STY 	MEMCORR
      	STAB	MEMOVERFLOW
      	STAA	MEMSENS
      	LDY 	CORRC1
      	LDAB	CORROFC1
      	LDAA	CORRSEC1
      	JSR 	AJOUTEMEM

	;ON REMET EN PLACE LES VALEURE SAUVEGARDEES
	; MOVW	TMPW,MEMCORR		;
	; MOVB	TMPB,MEMOVERFLOW	;
	; MOVB	TMPB1,MEMSENS		;  

    	STY 	CORRC1
      	STAB	CORROFC1
      	STAA	CORRSEC1	
;************************ENVOIS SCI (POUR FAIRE DES GRAPHIQUES D'EP POUR CEUX QUI AIME CA)
	BRA	CUMUL14  	;COMMENTER CETTE LIGNE POUR ACTIVER L'ENVOIS
CUMUL13	PSHA
      	LDAA	MEMSENS
      	JSR 	OUTSCI
      	JSR 	OUTSCI
      	JSR 	OUTSCI
      	LDAA	MEMOVERFLOW
      	JSR 	OUTSCI
      	JSR 	OUTSCI
      	JSR 	OUTSCI
      	LDAA	MEMCORR
      	JSR 	OUTSCI
      	JSR 	OUTSCI
      	JSR 	OUTSCI
      	LDAA	MEMCORR+1
      	JSR 	OUTSCI
      	JSR 	OUTSCI
      	JSR 	OUTSCI
      	LDAA	#'G'		
      	JSR 	OUTSCI
      	JSR 	OUTSCI
      	JSR 	OUTSCI
      	PULA
;*************************************
CUMUL14	CLR	MEMCORR
	CLR	MEMCORR+1
	CLR	MEMSENS
	CLR	MEMOVERFLOW
      	RTS
	
;******************
;* MEMCORRIGE() CETTE FONCTION MEMORISE ET CUMULE
;*            LA CORRECTION DEMANDEE DANS
;*
;*	     MEMCORR
;*	     MEMOVERFLOW
;*	     MEMSENS
;*
;* "Y" unchanged, VALEUR DE CORRECTION (MODULO $10000)  
;* "A" unchanged, SENS	$00=AD+	 $01=AD-
;* "B" unchanged, NOMBRE D'OVERFLOW A PRENDRE EN COMPTE
;******************
MEMCORRIGE
    	PSHX
    	PSHY
    	PSHA
    	PSHB
    	TST 	MEMCORR
    	BNE 	MEM1
    	TST 	MEMCORR+$01
    	BNE 	MEM1
    	TST 	MEMOVERFLOW
    	BNE 	MEM1
    	STY 	MEMCORR	  	;AUCUNE CORRECTION N'EST EN ATTENTE
    	STAA	MEMSENS	  	;
    	STAB	MEMOVERFLOW	;
    	JMP 	MEM2	    	;

MEM1	CMPA	MEMSENS 		;UNE CORRECTION EST DEJA EN ATTENTE
    	BNE 	MEM3
    	XGDY	          			;LES DEUX CORRECTIONS SONT DANS LE MEME SENS
    	ADDD	MEMCORR   			;"
    	BCC 	MEM4	      			;"
    	INC 	MEMOVERFLOW	   		;"
MEM4	STD 	MEMCORR	    			;"
    	XGDY			          	;"
    	ADDB	MEMOVERFLOW	  		;"
    	STAB	MEMOVERFLOW	  		;"
    	BRA 	MEM2		      		;"

MEM3              				;LES CORRECTION SONT DE SENS OPPOSEES
    	CMPB	MEMOVERFLOW	  		;"
    	BLO 	MEM5	      			;"
    	BEQ 	MEM6
    	SUBB	MEMOVERFLOW		    	;B>MEMOVERFLOW (LA NOUVELLE CORRECTION EST PLUS IMPORTANTE EN VALEURE ABS)
    	STAB	MEMOVERFLOW		    	;"
    	STAA	MEMSENS			      	;"
    	XGDY				        ;"
    	SUBD	MEMCORR		  	    	;"
    	BCC 	MEM7			        ;"
    	DEC 	MEMOVERFLOW		    	;"
MEM7	STD 	MEMCORR			      	;"
    	BRA 	MEM2			        ;"

MEM5	LDAA	MEMOVERFLOW	    		;B<MEMOVERFLOW (LA NOUVELLE CORRECTION EST MOINS IMPORTANTE EN VALEURE ABS)
    	SBA				        ;"
    	STAA	MEMOVERFLOW	    		;" MEMOVERFLOW=MEMOVERFLOW-B
MEM11	LDD 	MEMCORR			      	;"
    	XGDY				        ;"
    	STD 	MEMCORR			      	;"
    	XGDY				        ;"
    	SUBD	MEMCORR		      		;"
    	BCC 	MEM8			        ;"
    	DEC 	MEMOVERFLOW	    		;"
MEM8	STD 	MEMCORR			      	;" MEMCORR=MEMCORR-Y
    	BRA 	MEM2			        ;"

MEM6	LDAB	#0			        ;B=MEMOVERFLOW
    	STAB	MEMOVERFLOW	    		;"
    	XGDY				        ;"
    	CPD 	MEMCORR		      		;"
    	BEQ 	MEM9		        	;"
    	BLO 	MEM10	        		;"
    	SUBD	MEMCORR			        		;Y>MEMCORR
    	STD 	MEMCORR		        			;"
    	XGDY					              	;"
    	STAA	MEMSENS	        				;"
    	BRA 	MEM2		          			;"

MEM9	LDD 	#$0000	        				;Y=MEMCORR
    	STD 	MEMCORR		        			;"
    	STAA	MEMSENS		        			;"
    	BRA 	MEM2			           		;"
                          
MEM10	XGDY						        ;"
    	LDD 	MEMCORR			        		;Y<MEMCORR
    	XGDY					               	;"
    	STD 	MEMCORR			        		;"
    	XGDY					              	;"
    	SUBD	MEMCORR			        		;"
    	STD 	MEMCORR			        		;"

MEM2


    	PULB
    	PULA
    	PULY
    	PULX
    	RTS
;******************
;* AJOUTEMEM()	CUMULE LA CORRECTION DEMANDEE AVEC LES CORRECTIONS
;*		EN ATTENTE
;*
;*		RENVOI "Y" "A" ET "B" MIS A JOUR
;*
;* "Y" VALEUR DE CORRECTION (MODULO $10000) 
;* "A" SENS	$00=AD+	 $01=AD-
;* "B" NOMBRE D'OVERFLOW A PRENDRE EN COMPTE
;******************
AJOUTEMEM
    	JSR 	MEMCORRIGE
    	LDAA	MEMSENS
    	LDAB	MEMOVERFLOW
    	LDY 	MEMCORR
    	RTS



;***********************
;*ITOA()	converti un entier en caractre ascii
;*	Y ENTIER
;*	RESULTAT DANS ASCII 
;***********************
ITOA:
      	PSHA
      	PSHB
      	PSHX
      	PSHY
       	LDD   	#10000
      	LDX	#00110000B	;'0'
ITOA1: 	XGDX
      	STAB  	ASCII
      	XGDX
      	STD	TMPW
      	CPY    	TMPW
      	BLO   	ITOA2
      	CPD	#60000
      	BEQ	ITOA12
      	ADDD  	#10000
      	INX
      	BRA   	ITOA1
ITOA12	INX
      	XGDX
      	STAB  	ASCII
      	XGDX
      	BRA   	ITOA22

ITOA2: 	SUBD  	#10000
ITOA22	STD   	TMPW
      	XGDY
      	SUBD  	TMPW
      	XGDY
      	LDD   	#1000
      	LDX   	#00110000B	;'0'
ITOA21:	XGDX
      	STAB  	ASCII+1
      	XGDX
      	STD   	TMPW
      	CPY   	TMPW
      	BLO   	ITOA3
      	ADDD  	#1000
      	INX
      	BRA   	ITOA21

ITOA3: 	SUBD  	#1000
      	STD   	TMPW
      	XGDY
      	SUBD  	TMPW
      	XGDY
      	LDD   	#100
      	LDX   	#00110000B	;'0'
ITOA31:	XGDX
      	STAB  	ASCII+2
      	XGDX
      	STD   	TMPW
      	CPY	TMPW
      	BLO	ITOA4
      	ADDD   	#100
      	INX
      	BRA   	ITOA31
	
ITOA4: 	SUBD  	#100
      	STD   	TMPW
      	XGDY
      	SUBD  	TMPW
      	XGDY
      	LDD   	#10
      	LDX   	#00110000B	;'0'
ITOA41:	XGDX
      	STAB  	ASCII+3
      	XGDX
      	STD   	TMPW
      	CPY   	TMPW
      	BLO   	ITOA5
      	ADDD   	#10
      	INX
      	BRA   	ITOA41

ITOA5: 	SUBD  	#10
      	STD   	TMPW
      	XGDY
      	SUBD  	TMPW
      	XGDY
      	LDD   	#1
      	LDX   	#00110000B	;'0'
ITOA51:	XGDX
      	STAB  	ASCII+4
      	XGDX
      	STD   	TMPW
      	CPY   	TMPW
      	BLO   	ITOA6
      	ADDD  	#1
      	INX
      	BRA   	ITOA51

ITOA6:	PULY
      	PULX
      	PULB
      	PULA
      	RTS



